## kwin 6.4.5

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

set(PROJECT_VERSION "6.4.5") # Handled by release scripts
project(KWin VERSION ${PROJECT_VERSION})

set(CMAKE_C_STANDARD 99)
set(CMAKE_CXX_STANDARD 23)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

set(PROJECT_DEP_VERSION "6.4.5")
set(QT_MIN_VERSION "6.8.0")
set(KF6_MIN_VERSION "6.14.0")
set(KDE_COMPILERSETTINGS_LEVEL "5.82")

find_package(ECM ${KF6_MIN_VERSION} REQUIRED NO_MODULE)

# where to look first for cmake modules, before ${CMAKE_ROOT}/Modules/ is checked
set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules ${ECM_MODULE_PATH})

include(CMakeDependentOption)
include(CMakePackageConfigHelpers)
include(FeatureSummary)
include(WriteBasicConfigVersionFile)
include(GenerateExportHeader)
include(CheckCXXSourceCompiles)
include(CheckCXXCompilerFlag)
include(CheckIncludeFile)
include(CheckIncludeFiles)
include(CheckSymbolExists)

include(KDEInstallDirs)
include(KDECMakeSettings)
include(KDECompilerSettings NO_POLICY_SCOPE)
include(KDEClangFormat)
include(KDEGitCommitHooks)

include(ECMFindQmlModule)
include(ECMInstallIcons)
include(ECMOptionalAddSubdirectory)
include(ECMConfiguredInstall)
include(ECMQtDeclareLoggingCategory)
include(ECMSetupQtPluginMacroNames)
include(ECMSetupVersion)
include(ECMQmlModule)
include(ECMGenerateQmlTypes)
include(ECMDeprecationSettings)
include(ECMGenerateQDoc)

option(KWIN_BUILD_DECORATIONS "Enable building of KWin decorations." ON)
option(KWIN_BUILD_KCMS "Enable building of KWin configuration modules." ON)
option(KWIN_BUILD_NOTIFICATIONS "Enable building of KWin with knotifications support" ON)
option(KWIN_BUILD_SCREENLOCKER "Enable building of KWin lockscreen functionality" ON)
option(KWIN_BUILD_TABBOX "Enable building of KWin Tabbox functionality" ON)
option(KWIN_BUILD_X11 "Enable building X11 common code and Xwayland support" ON)
option(KWIN_BUILD_GLOBALSHORTCUTS "Enable building of KWin with global shortcuts support" ON)
option(KWIN_BUILD_RUNNERS "Enable building of KWin with krunner support" ON)

find_package(Qt6 ${QT_MIN_VERSION} CONFIG REQUIRED COMPONENTS
    Concurrent
    Core
    Core5Compat
    DBus
    Quick
    UiTools
    WaylandClient
    Widgets
    Sensors
    Svg
)

if (Qt6Gui_VERSION VERSION_GREATER_EQUAL "6.10.0")
    find_package(Qt6GuiPrivate ${REQUIRED_QT_VERSION} REQUIRED NO_MODULE)
endif()

find_package(Qt6Test ${QT_MIN_VERSION} CONFIG QUIET)
set_package_properties(Qt6Test PROPERTIES
    PURPOSE "Required for tests"
    TYPE OPTIONAL
)
add_feature_info("Qt6Test" Qt6Test_FOUND "Required for building tests")
if (NOT Qt6Test_FOUND)
    set(BUILD_TESTING OFF CACHE BOOL "Build the testing tree.")
endif()

if (BUILD_TESTING)
    find_package(KPipeWire)
endif()

# required frameworks by Core
find_package(KF6 ${KF6_MIN_VERSION} REQUIRED COMPONENTS
    Auth
    ColorScheme
    Config
    CoreAddons
    Crash
    DBusAddons
    GlobalAccel
    GuiAddons
    I18n
    IdleTime
    Package
    Service
    Svg
    WidgetsAddons
    WindowSystem
)
# required frameworks by config modules
if(KWIN_BUILD_KCMS)
    find_package(KF6 ${KF6_MIN_VERSION} REQUIRED COMPONENTS
        Declarative
        KCMUtils
        NewStuff
        Service
        XmlGui
    )
endif()

if(KWIN_BUILD_TABBOX AND KWIN_BUILD_KCMS)
    find_package(KF6 ${KF6_MIN_VERSION} REQUIRED COMPONENTS
        WidgetsAddons
    )
endif()

find_package(Threads)
set_package_properties(Threads PROPERTIES
    PURPOSE "Needed for VirtualTerminal support in KWin Wayland"
    TYPE REQUIRED
)

find_package(KWayland ${PROJECT_DEP_VERSION} CONFIG)
set_package_properties(KWayland PROPERTIES
    PURPOSE "Required to build wayland platform plugin and tests"
    TYPE REQUIRED
)

# optional frameworks
find_package(PlasmaActivities ${PROJECT_DEP_VERSION} CONFIG)
set_package_properties(PlasmaActivities PROPERTIES
    PURPOSE "Enable building of KWin with kactivities support"
    TYPE OPTIONAL
)
add_feature_info("PlasmaActivities" PlasmaActivities_FOUND "Enable building of KWin with kactivities support")

find_package(KF6DocTools ${KF6_MIN_VERSION} CONFIG)
set_package_properties(KF6DocTools PROPERTIES
    PURPOSE "Enable building documentation"
    TYPE OPTIONAL
)
add_feature_info("KF6DocTools" KF6DocTools_FOUND "Enable building documentation")

find_package(KF6Kirigami ${KF6_MIN_VERSION} CONFIG)
set_package_properties(KF6Kirigami PROPERTIES
    DESCRIPTION "A QtQuick based components set"
    PURPOSE "Required at runtime for several QML effects"
    TYPE RUNTIME
)
find_package(Plasma ${PROJECT_DEP_VERSION} CONFIG)
set_package_properties(Plasma PROPERTIES
    DESCRIPTION "A QtQuick based components set"
    PURPOSE "Required at runtime for several QML effects"
    TYPE RUNTIME
)

find_package(KDecoration3 ${PROJECT_DEP_VERSION} CONFIG REQUIRED)

if (KWIN_BUILD_DECORATIONS)
    find_package(Breeze ${PROJECT_DEP_VERSION} CONFIG)
    set_package_properties(Breeze PROPERTIES
        TYPE RUNTIME
        PURPOSE "For setting the default window decoration plugin"
    )

    find_package(Aurorae ${PROJECT_DEP_VERSION} CONFIG)
    set_package_properties(Aurorae PROPERTIES
        TYPE RUNTIME
        PURPOSE "Provides support for decorations downloaded from the internet"
    )
endif()

find_package(EGL)
set_package_properties(EGL PROPERTIES
    TYPE REQUIRED
    PURPOSE "Required to build KWin with EGL support"
)

find_package(epoxy 1.3)
set_package_properties(epoxy PROPERTIES
    DESCRIPTION "libepoxy"
    URL "https://github.com/anholt/libepoxy"
    TYPE REQUIRED
    PURPOSE "OpenGL dispatch library"
)

find_package(Wayland 1.23)
set_package_properties(Wayland PROPERTIES
    TYPE REQUIRED
    PURPOSE "Required for building KWin with Wayland support"
)
if (Wayland_VERSION VERSION_GREATER_EQUAL 1.23)
    set(HAVE_WL_DISPLAY_SET_DEFAULT_MAX_BUFFER_SIZE 1)
else()
    set(HAVE_WL_DISPLAY_SET_DEFAULT_MAX_BUFFER_SIZE 0)
endif()
if (Wayland_VERSION VERSION_GREATER_EQUAL 1.23.90)
    set(HAVE_WL_FIXES 1)
else()
    set(HAVE_WL_FIXES 0)
endif()

find_package(WaylandProtocols 1.44)
set_package_properties(WaylandProtocols PROPERTIES
    TYPE REQUIRED
    PURPOSE "Collection of Wayland protocols that add functionality not available in the Wayland core protocol"
    URL "https://gitlab.freedesktop.org/wayland/wayland-protocols/"
)

find_package(PlasmaWaylandProtocols 1.18.0 CONFIG)
set_package_properties(PlasmaWaylandProtocols PROPERTIES
    TYPE REQUIRED
    PURPOSE "Collection of Plasma-specific Wayland protocols"
    URL "https://invent.kde.org/libraries/plasma-wayland-protocols/"
)

find_package(XKB 0.7.0)
set_package_properties(XKB PROPERTIES
    TYPE REQUIRED
    PURPOSE "Required for building KWin with Wayland support"
)
if (XKB_VERSION VERSION_GREATER_EQUAL 1.5.0)
    set(HAVE_XKBCOMMON_NO_SECURE_GETENV 1)
else()
    set(HAVE_XKBCOMMON_NO_SECURE_GETENV 0)
endif()

find_package(Canberra REQUIRED)

if (KWIN_BUILD_X11)
    pkg_check_modules(XKBX11 IMPORTED_TARGET xkbcommon-x11 REQUIRED)
    add_feature_info(XKBX11 XKBX11_FOUND "Required for handling keyboard events in X11 backend")

    # All the required XCB components
    find_package(XCB 1.10 REQUIRED COMPONENTS
        COMPOSITE
        CURSOR
        DRI3
        ICCCM
        KEYSYMS
        PRESENT
        RANDR
        RENDER
        RES
        SHAPE
        SHM
        SYNC
        XCB
        XFIXES
        XINERAMA
        XINPUT
    )
    set_package_properties(XCB PROPERTIES TYPE REQUIRED)

    find_package(X11_XCB)
    set_package_properties(X11_XCB PROPERTIES
        PURPOSE "Required for building X11 windowed backend of kwin_wayland"
        TYPE OPTIONAL
    )

    find_package(Xwayland 23.1.0)
    set_package_properties(Xwayland PROPERTIES
        URL "https://x.org"
        DESCRIPTION "Xwayland X server"
        TYPE RUNTIME
        PURPOSE "Needed for running kwin_wayland"
    )
    set(HAVE_XWAYLAND_ENABLE_EI_PORTAL ${Xwayland_HAVE_ENABLE_EI_PORTAL})

    # for kwin internal things
    set(HAVE_X11_XCB ${X11_XCB_FOUND})

    find_package(X11)
    set_package_properties(X11 PROPERTIES
        DESCRIPTION "X11 libraries"
        URL "https://www.x.org"
        TYPE REQUIRED
    )

    # Scripts to run on XWayland startup
    set(XWAYLAND_SESSION_SCRIPTS "/etc/xdg/Xwayland-session.d")
endif()

find_package(Libinput 1.26)
set_package_properties(Libinput PROPERTIES TYPE REQUIRED PURPOSE "Required for input handling on Wayland.")
if (Libinput_VERSION VERSION_GREATER_EQUAL 1.27)
    set(HAVE_LIBINPUT_INPUT_AREA 1)
else()
    set(HAVE_LIBINPUT_INPUT_AREA 0)
endif()

find_package(Libeis-1.0)
set_package_properties(Libeis PROPERTIES TYPE OPTIONAL PURPOSE "Required for emulated input handling.")

find_package(UDev)
set_package_properties(UDev PROPERTIES
    URL "https://www.freedesktop.org/wiki/Software/systemd/"
    DESCRIPTION "Linux device library."
    TYPE REQUIRED
    PURPOSE "Required for input handling on Wayland."
)

find_package(Libdrm 2.4.118)
set_package_properties(Libdrm PROPERTIES TYPE REQUIRED PURPOSE "Required for drm output on Wayland.")

find_package(gbm)
set_package_properties(gbm PROPERTIES TYPE REQUIRED PURPOSE "Required for egl output of drm backend.")
if (gbm_VERSION VERSION_GREATER_EQUAL 21.1)
    set(HAVE_GBM_BO_GET_FD_FOR_PLANE 1)
else()
    set(HAVE_GBM_BO_GET_FD_FOR_PLANE 0)
endif()
if (gbm_VERSION VERSION_GREATER_EQUAL 21.3)
    set(HAVE_GBM_BO_CREATE_WITH_MODIFIERS2 1)
else()
    set(HAVE_GBM_BO_CREATE_WITH_MODIFIERS2 0)
endif()

pkg_check_modules(Libxcvt IMPORTED_TARGET libxcvt>=0.1.1 REQUIRED)
add_feature_info(Libxcvt Libxcvt_FOUND "Required for generating modes in the drm backend")

add_feature_info("XInput" X11_Xi_FOUND "Required for poll-free mouse cursor updates")
set(HAVE_X11_XINPUT ${X11_Xinput_FOUND})

find_package(lcms2)
set_package_properties(lcms2 PROPERTIES
    DESCRIPTION "Small-footprint color management engine"
    URL "http://www.littlecms.com"
    TYPE REQUIRED
    PURPOSE "Required for the color management system"
)

find_package(Freetype)
set_package_properties(Freetype PROPERTIES
    DESCRIPTION "A font rendering engine"
    URL "https://www.freetype.org"
    TYPE REQUIRED
    PURPOSE "Needed for KWin's QPA plugin."
)
find_package(Fontconfig)
set_package_properties(Fontconfig PROPERTIES
    TYPE REQUIRED
    PURPOSE "Needed for KWin's QPA plugin."
)

find_package(hwdata)
set_package_properties(hwdata PROPERTIES
    TYPE RUNTIME
    PURPOSE "Runtime-only dependency needed for mapping monitor hardware vendor IDs to full names"
    URL "https://github.com/vcrhonek/hwdata"
)

find_package(QAccessibilityClient6 CONFIG)
set_package_properties(QAccessibilityClient6 PROPERTIES
    URL "https://commits.kde.org/libqaccessibilityclient"
    DESCRIPTION "KDE client-side accessibility library"
    TYPE OPTIONAL
    PURPOSE "Required to enable accessibility features"
)
set(HAVE_ACCESSIBILITY ${QAccessibilityClient6_FOUND})

pkg_check_modules(libsystemd IMPORTED_TARGET libsystemd)
add_feature_info(libsystemd libsystemd_FOUND "Required for setting up the service watchdog")

if(KWIN_BUILD_GLOBALSHORTCUTS)
    find_package(KGlobalAccelD REQUIRED)
endif()

pkg_check_modules(libdisplayinfo REQUIRED IMPORTED_TARGET libdisplay-info>=0.2.0)
add_feature_info(libdisplayinfo libdisplayinfo_FOUND "EDID and DisplayID library: https://gitlab.freedesktop.org/emersion/libdisplay-info")

pkg_check_modules(PipeWire IMPORTED_TARGET libpipewire-0.3>=1.0.9)
add_feature_info(PipeWire PipeWire_FOUND "Required for Wayland screencasting")

if (KWIN_BUILD_NOTIFICATIONS)
    find_package(KF6 ${KF6_MIN_VERSION} REQUIRED COMPONENTS Notifications)
endif()

if (KWIN_BUILD_SCREENLOCKER)
    find_package(KScreenLocker CONFIG)
    set_package_properties(KScreenLocker PROPERTIES
        TYPE REQUIRED
        PURPOSE "For screenlocker integration in kwin_wayland"
    )
endif()

ecm_find_qmlmodule(QtQuick 2.3)
ecm_find_qmlmodule(QtQuick.Controls 2.15)
ecm_find_qmlmodule(QtQuick.Layouts 1.3)
ecm_find_qmlmodule(QtQuick.Window 2.1)
ecm_find_qmlmodule(org.kde.kquickcontrolsaddons 2.0)

=== data/CMakeLists.txt ===
add_subdirectory(icons)

########### next target ###############
add_executable(kwin5_update_default_rules update_default_rules.cpp)
target_link_libraries(kwin5_update_default_rules
    KF6::ConfigCore
    Qt::Core
    Qt::DBus
)
install(TARGETS kwin5_update_default_rules DESTINATION ${KDE_INSTALL_LIBDIR}/kconf_update_bin/)

########### install files ###############

install(FILES org_kde_kwin.categories DESTINATION ${KDE_INSTALL_LOGGINGCATEGORIESDIR})

=== tests/CMakeLists.txt ===
if(KWIN_BUILD_X11)
    set(normalhintsbasesizetest_SRCS normalhintsbasesizetest.cpp)
    add_executable(normalhintsbasesizetest ${normalhintsbasesizetest_SRCS})
    target_link_libraries(normalhintsbasesizetest XCB::XCB XCB::ICCCM KF6::WindowSystem)

    add_executable(x11shadowreader x11shadowreader.cpp)
    target_link_libraries(x11shadowreader XCB::XCB Qt::GuiPrivate Qt::Widgets KF6::ConfigCore KF6::WindowSystem)

    add_executable(pointerconstraints pointerconstraintstest.cpp)
    add_definitions(-DDIR="${CMAKE_CURRENT_SOURCE_DIR}")
    target_link_libraries(pointerconstraints XCB::XCB Qt::Gui Qt::Quick Plasma::KWaylandClient)
endif()

add_executable(pointergestures pointergesturestest.cpp)
add_definitions(-DDIR="${CMAKE_CURRENT_SOURCE_DIR}")
target_link_libraries(pointergestures Qt::Gui Qt::Quick Plasma::KWaylandClient)

add_executable(cursorhotspottest cursorhotspottest.cpp)
target_link_libraries(cursorhotspottest Qt::Widgets)

include_directories(${CMAKE_CURRENT_BINARY_DIR})

add_executable(xdgactivationtest-qt6 xdgactivationtest-qt6.cpp)
target_link_libraries(xdgactivationtest-qt6 Qt6::Widgets)

set(testServer_SRCS
    waylandservertest.cpp
    fakeoutput.cpp
    )
add_executable(testServer ${testServer_SRCS})
target_link_libraries(testServer kwin Qt::CorePrivate)

find_package(Qt6Widgets ${QT_MIN_VERSION} CONFIG QUIET)
if (TARGET Qt::Widgets)
    set(testRenderingServer_SRCS
        renderingservertest.cpp
        fakeoutput.cpp
        )
    add_executable(testRenderingServer ${testRenderingServer_SRCS})
    target_link_libraries(testRenderingServer kwin Qt::Core Qt::Widgets)
endif()

add_executable(copyClient copyclient.cpp)
target_link_libraries(copyClient Plasma::KWaylandClient)

add_executable(pasteClient pasteclient.cpp)
target_link_libraries(pasteClient Qt::Core Plasma::KWaylandClient)

add_executable(touchClientTest touchclienttest.cpp)
target_link_libraries(touchClientTest Plasma::KWaylandClient)

add_executable(panelTest paneltest.cpp)
target_link_libraries(panelTest Plasma::KWaylandClient)

add_executable(subsurface-test subsurfacetest.cpp)
target_link_libraries(subsurface-test Qt::Core Qt::Gui Plasma::KWaylandClient)

add_executable(shadowTest shadowtest.cpp)
target_link_libraries(shadowTest Plasma::KWaylandClient)

if (TARGET Qt::Widgets)
    add_executable(dpmsTest dpmstest.cpp)
    target_link_libraries(dpmsTest Plasma::KWaylandClient Qt::Widgets)
endif()

add_executable(plasmasurface-test plasmasurfacetest.cpp)
target_link_libraries(plasmasurface-test Qt::Gui Plasma::KWaylandClient)

add_executable(xdgforeign-test xdgforeigntest.cpp)
target_link_libraries(xdgforeign-test Qt::Gui Plasma::KWaylandClient)

add_executable(xdg-test xdgtest.cpp)
target_link_libraries(xdg-test Qt::Gui Plasma::KWaylandClient)

if (Qt6_VERSION VERSION_GREATER_EQUAL "6.8.0")
    set(private_code_option  "PRIVATE_CODE")
endif()
add_executable(xdgsessiontest xdgsessiontest.cpp)
qt6_generate_wayland_protocol_client_sources(xdgsessiontest
    ${private_code_option}
    NO_INCLUDE_CORE_ONLY
    FILES
     ${PROJECT_SOURCE_DIR}/src/wayland/protocols/xx-session-management-v1.xml
     ${WaylandProtocols_DATADIR}/stable/xdg-shell/xdg-shell.xml
)
target_link_libraries(xdgsessiontest
    Qt::Core
    Qt::Widgets
    Qt::GuiPrivate
    Qt::WaylandClient
)

add_executable(lockscreenoverlaytest lockscreenoverlaytest.cpp)
target_link_libraries(lockscreenoverlaytest Qt::Widgets Qt::WaylandClient Qt::WaylandClientPrivate Wayland::Client KF6::WindowSystem)
qt6_generate_wayland_protocol_client_sources(lockscreenoverlaytest
    ${private_code_option}
    FILES
        ${PLASMA_WAYLAND_PROTOCOLS_DIR}/kde-lockscreen-overlay-v1.xml
)

=== autotests/drm/CMakeLists.txt ===
set(mockDRM_SRCS
    mock_drm.cpp
    ../../src/backends/drm/drm_abstract_output.cpp
    ../../src/backends/drm/drm_backend.cpp
    ../../src/backends/drm/drm_blob.cpp
    ../../src/backends/drm/drm_buffer.cpp
    ../../src/backends/drm/drm_colorop.cpp
    ../../src/backends/drm/drm_commit.cpp
    ../../src/backends/drm/drm_commit_thread.cpp
    ../../src/backends/drm/drm_connector.cpp
    ../../src/backends/drm/drm_crtc.cpp
    ../../src/backends/drm/drm_egl_backend.cpp
    ../../src/backends/drm/drm_egl_layer.cpp
    ../../src/backends/drm/drm_egl_layer_surface.cpp
    ../../src/backends/drm/drm_gpu.cpp
    ../../src/backends/drm/drm_layer.cpp
    ../../src/backends/drm/drm_logging.cpp
    ../../src/backends/drm/drm_object.cpp
    ../../src/backends/drm/drm_output.cpp
    ../../src/backends/drm/drm_pipeline.cpp
    ../../src/backends/drm/drm_pipeline_legacy.cpp
    ../../src/backends/drm/drm_plane.cpp
    ../../src/backends/drm/drm_property.cpp
    ../../src/backends/drm/drm_qpainter_backend.cpp
    ../../src/backends/drm/drm_qpainter_layer.cpp
    ../../src/backends/drm/drm_virtual_egl_layer.cpp
    ../../src/backends/drm/drm_virtual_output.cpp
)

include_directories(${Libdrm_INCLUDE_DIRS})

add_library(LibDrmTest STATIC ${mockDRM_SRCS})
target_link_libraries(LibDrmTest
    Qt::Gui
    Qt::Widgets
    KF6::ConfigCore
    KF6::WindowSystem
    KF6::CoreAddons
    KF6::I18n
    PkgConfig::Libxcvt
    gbm::gbm
    Libdrm::Libdrm
    kwin
)
target_include_directories(LibDrmTest
    PUBLIC
        ../../src
        ../../src/backends/drm/
)

########################################################
# Tests
########################################################
add_executable(testDrm drmTest.cpp)
target_link_libraries(testDrm LibDrmTest Qt::Test)
add_test(NAME kwin-testDrm COMMAND testDrm)
ecm_mark_as_test(testDrm)

=== autotests/libinput/CMakeLists.txt ===
include_directories(${Libinput_INCLUDE_DIRS})

add_definitions(-DKWIN_BUILD_TESTING)
add_library(LibInputTestObjects STATIC ../../src/backends/libinput/device.cpp ../../src/backends/libinput/events.cpp ../../src/core/inputdevice.cpp ../../src/mousebuttons.cpp mock_libinput.cpp)
target_link_libraries(LibInputTestObjects Qt::Test Qt::Widgets Qt::DBus Qt::Gui KF6::ConfigCore)
target_include_directories(LibInputTestObjects PUBLIC ${CMAKE_SOURCE_DIR}/src)

########################################################
# Test Devices
########################################################
add_executable(testLibinputDevice device_test.cpp)
target_link_libraries(testLibinputDevice Qt::Test Qt::DBus Qt::Gui KF6::ConfigCore LibInputTestObjects)
add_test(NAME kwin-testLibinputDevice COMMAND testLibinputDevice)
ecm_mark_as_test(testLibinputDevice)

########################################################
# Test Key Event
########################################################
add_executable(testLibinputKeyEvent key_event_test.cpp)
target_link_libraries(testLibinputKeyEvent Qt::Test Qt::DBus Qt::Widgets KF6::ConfigCore LibInputTestObjects)
add_test(NAME kwin-testLibinputKeyEvent COMMAND testLibinputKeyEvent)
ecm_mark_as_test(testLibinputKeyEvent)

########################################################
# Test Pointer Event
########################################################
add_executable(testLibinputPointerEvent pointer_event_test.cpp)
target_link_libraries(testLibinputPointerEvent Qt::Test Qt::DBus Qt::Widgets KF6::ConfigCore LibInputTestObjects)
add_test(NAME kwin-testLibinputPointerEvent COMMAND testLibinputPointerEvent)
ecm_mark_as_test(testLibinputPointerEvent)

########################################################
# Test Touch Event
########################################################
add_executable(testLibinputTouchEvent touch_event_test.cpp)
target_link_libraries(testLibinputTouchEvent Qt::Test Qt::DBus Qt::Widgets KF6::ConfigCore LibInputTestObjects)
add_test(NAME kwin-testLibinputTouchEvent COMMAND testLibinputTouchEvent)
ecm_mark_as_test(testLibinputTouchEvent)

########################################################
# Test Gesture Event
########################################################
add_executable(testLibinputGestureEvent gesture_event_test.cpp)
target_link_libraries(testLibinputGestureEvent Qt::Test Qt::DBus Qt::Widgets KF6::ConfigCore LibInputTestObjects)
add_test(NAME kwin-testLibinputGestureEvent COMMAND testLibinputGestureEvent)
ecm_mark_as_test(testLibinputGestureEvent)

=== src/helpers/CMakeLists.txt ===
add_subdirectory(killer)
add_subdirectory(wayland_wrapper)

=== src/plugins/CMakeLists.txt ===
function(kwin_add_effect_config name)
    list(REMOVE_ITEM ARGV ${name})
    kcoreaddons_add_plugin(${name} INSTALL_NAMESPACE "kwin/effects/configs" SOURCES ${ARGV})
    target_compile_definitions(${name} PRIVATE -DTRANSLATION_DOMAIN=\"kwin\")
endfunction()

# Add a CMake-time check for python3 to avoid failures during build.
find_package (Python3 COMPONENTS Interpreter)
add_feature_info("Python3" Python3_Interpreter_FOUND "Required to strip effects metadata")
set(KSEM_EXE "${CMAKE_CURRENT_SOURCE_DIR}/strip-effect-metadata.py")

function (kwin_strip_builtin_effect_metadata target metadata)
    set(stripped_metadata "${CMAKE_CURRENT_BINARY_DIR}/${metadata}.stripped")

    set(command ${KSEM_EXE} --source=${metadata} --output=${stripped_metadata})
    add_custom_command(
        OUTPUT ${stripped_metadata}
        COMMAND ${command}
        WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
        DEPENDS ${metadata}
        COMMENT "Stripping ${metadata}..."
    )
    set_property(TARGET ${target} APPEND PROPERTY AUTOGEN_TARGET_DEPENDS ${stripped_metadata})
endfunction()

macro(kwin_add_builtin_effect name)
    kcoreaddons_add_plugin(${name} STATIC SOURCES ${ARGN} INSTALL_NAMESPACE "kwin/effects/plugins")
    target_compile_definitions(${name} PRIVATE -DTRANSLATION_DOMAIN=\"kwin\")
    kwin_strip_builtin_effect_metadata(${name} metadata.json)
    install(FILES metadata.json DESTINATION ${KDE_INSTALL_DATADIR}/kwin-wayland/builtin-effects/ RENAME ${name}.json)
endmacro()

function(kwin_add_scripted_effect name source)
    kpackage_install_package(${source} ${name} effects kwin-wayland)

    # necessary so tests are found without installing
    file(COPY ${source}/contents ${source}/metadata.json DESTINATION ${CMAKE_BINARY_DIR}/bin/kwin-wayland/effects/${name})
endfunction()

function(kwin_add_script name source)
    kpackage_install_package(${source} ${name} scripts kwin-wayland)

    # Copy the script to the build directory so one can run tests without prior
    # make install. FIXME: use add_custom_command.
    file(COPY ${source}/contents ${source}/metadata.json DESTINATION ${CMAKE_BINARY_DIR}/bin/kwin-wayland/scripts/${name})
endfunction()

add_subdirectory(private)

add_subdirectory(backgroundcontrast)
add_subdirectory(blendchanges)
add_subdirectory(blur)
add_subdirectory(bouncekeys)
add_subdirectory(buttonrebinds)
add_subdirectory(colorblindnesscorrection)
add_subdirectory(colorpicker)
add_subdirectory(desktopchangeosd)
add_subdirectory(dialogparent)
add_subdirectory(diminactive)
add_subdirectory(dimscreen)
add_subdirectory(eyeonscreen)
add_subdirectory(fade)
add_subdirectory(fadedesktop)
add_subdirectory(fadingpopups)
add_subdirectory(fallapart)
add_subdirectory(frozenapp)
add_subdirectory(fullscreen)
add_subdirectory(glide)
add_subdirectory(hidecursor)
add_subdirectory(highlightwindow)
add_subdirectory(idletime)
add_subdirectory(invert)
add_subdirectory(kpackage)
add_subdirectory(kscreen)
add_subdirectory(login)
add_subdirectory(logout)
add_subdirectory(magiclamp)
add_subdirectory(magnifier)
add_subdirectory(maximize)
add_subdirectory(minimizeall)
add_subdirectory(mouseclick)
add_subdirectory(mousekeys)
add_subdirectory(mousemark)
add_subdirectory(nightlight)
add_subdirectory(outputlocator)
add_subdirectory(overview)
add_subdirectory(qpa)
add_subdirectory(scale)
add_subdirectory(screenedge)
add_subdirectory(screenshot)
add_subdirectory(screentransform)
add_subdirectory(sessionquit)
add_subdirectory(shakecursor)
add_subdirectory(sheet)
add_subdirectory(showcompositing)
add_subdirectory(showfps)
add_subdirectory(showpaint)
add_subdirectory(slide)
add_subdirectory(slideback)
add_subdirectory(slidingpopups)
add_subdirectory(squash)
add_subdirectory(startupfeedback)
add_subdirectory(stickykeys)
add_subdirectory(synchronizeskipswitcher)
add_subdirectory(systembell)
add_subdirectory(thumbnailaside)
add_subdirectory(tileseditor)
add_subdirectory(touchpadshortcuts)
add_subdirectory(touchpoints)
add_subdirectory(trackmouse)
add_subdirectory(translucency)
add_subdirectory(videowall)
add_subdirectory(windowaperture)
add_subdirectory(windowsystem)
add_subdirectory(windowview)
add_subdirectory(wobblywindows)
add_subdirectory(zoom)

if (KWIN_BUILD_NOTIFICATIONS)
    add_subdirectory(keynotification)
endif()

if (PipeWire_FOUND)
    add_subdirectory(screencast)
endif()
if (KWIN_BUILD_RUNNERS)
    add_subdirectory(krunner-integration)
endif()
if(TARGET K::KGlobalAccelD)
    add_subdirectory(kglobalaccel)
endif()
if (KWIN_BUILD_EIS)
    add_subdirectory(eis)
endif()

=== src/wayland/CMakeLists.txt ===
add_subdirectory(tools)

# CMake has a known bug where target_source() doesn't work as expected with files generated
# in a directory other than the one where the target is defined. It should be fixed in 3.20.
add_library(WaylandProtocols_xml OBJECT)
set_property(TARGET WaylandProtocols_xml PROPERTY POSITION_INDEPENDENT_CODE ON)
target_link_libraries(WaylandProtocols_xml Qt::Core Wayland::Server)
target_link_libraries(kwin PRIVATE WaylandProtocols_xml)

ecm_add_qtwayland_server_protocol_kde(WaylandProtocols_xml
    PRIVATE_CODE
    FILES
        ${Wayland_DATADIR}/wayland.xml

        ${PLASMA_WAYLAND_PROTOCOLS_DIR}/appmenu.xml
        ${PLASMA_WAYLAND_PROTOCOLS_DIR}/blur.xml
        ${PLASMA_WAYLAND_PROTOCOLS_DIR}/contrast.xml
        ${PLASMA_WAYLAND_PROTOCOLS_DIR}/dpms.xml
        ${PLASMA_WAYLAND_PROTOCOLS_DIR}/fake-input.xml
        ${PLASMA_WAYLAND_PROTOCOLS_DIR}/idle.xml
        ${PLASMA_WAYLAND_PROTOCOLS_DIR}/kde-external-brightness-v1.xml
        ${PLASMA_WAYLAND_PROTOCOLS_DIR}/kde-lockscreen-overlay-v1.xml
        ${PLASMA_WAYLAND_PROTOCOLS_DIR}/kde-output-device-v2.xml
        ${PLASMA_WAYLAND_PROTOCOLS_DIR}/kde-output-management-v2.xml
        ${PLASMA_WAYLAND_PROTOCOLS_DIR}/kde-output-order-v1.xml
        ${PLASMA_WAYLAND_PROTOCOLS_DIR}/kde-screen-edge-v1.xml
        ${PLASMA_WAYLAND_PROTOCOLS_DIR}/keystate.xml
        ${PLASMA_WAYLAND_PROTOCOLS_DIR}/org-kde-plasma-virtual-desktop.xml
        ${PLASMA_WAYLAND_PROTOCOLS_DIR}/plasma-shell.xml
        ${PLASMA_WAYLAND_PROTOCOLS_DIR}/plasma-window-management.xml
        ${PLASMA_WAYLAND_PROTOCOLS_DIR}/server-decoration-palette.xml
        ${PLASMA_WAYLAND_PROTOCOLS_DIR}/server-decoration.xml
        ${PLASMA_WAYLAND_PROTOCOLS_DIR}/shadow.xml
        ${PLASMA_WAYLAND_PROTOCOLS_DIR}/slide.xml
        ${PLASMA_WAYLAND_PROTOCOLS_DIR}/text-input-unstable-v2.xml
        ${PLASMA_WAYLAND_PROTOCOLS_DIR}/zkde-screencast-unstable-v1.xml

        ${PROJECT_SOURCE_DIR}/src/wayland/protocols/drm.xml
        ${PROJECT_SOURCE_DIR}/src/wayland/protocols/frog-color-management-v1.xml
        ${PROJECT_SOURCE_DIR}/src/wayland/protocols/wlr-data-control-unstable-v1.xml
        ${PROJECT_SOURCE_DIR}/src/wayland/protocols/wlr-layer-shell-unstable-v1.xml
        ${PROJECT_SOURCE_DIR}/src/wayland/protocols/xx-session-management-v1.xml

        ${WaylandProtocols_DATADIR}/stable/presentation-time/presentation-time.xml
        ${WaylandProtocols_DATADIR}/stable/tablet/tablet-v2.xml
        ${WaylandProtocols_DATADIR}/stable/viewporter/viewporter.xml
        ${WaylandProtocols_DATADIR}/stable/xdg-shell/xdg-shell.xml
        ${WaylandProtocols_DATADIR}/staging/alpha-modifier/alpha-modifier-v1.xml
        ${WaylandProtocols_DATADIR}/staging/color-management/color-management-v1.xml
        ${WaylandProtocols_DATADIR}/staging/color-representation/color-representation-v1.xml
        ${WaylandProtocols_DATADIR}/staging/content-type/content-type-v1.xml
        ${WaylandProtocols_DATADIR}/staging/cursor-shape/cursor-shape-v1.xml
        ${WaylandProtocols_DATADIR}/staging/drm-lease/drm-lease-v1.xml
        ${WaylandProtocols_DATADIR}/staging/ext-data-control/ext-data-control-v1.xml
        ${WaylandProtocols_DATADIR}/staging/ext-idle-notify/ext-idle-notify-v1.xml
        ${WaylandProtocols_DATADIR}/staging/fifo/fifo-v1.xml
        ${WaylandProtocols_DATADIR}/staging/fractional-scale/fractional-scale-v1.xml
        ${WaylandProtocols_DATADIR}/staging/linux-drm-syncobj/linux-drm-syncobj-v1.xml
        ${WaylandProtocols_DATADIR}/staging/security-context/security-context-v1.xml
        ${WaylandProtocols_DATADIR}/staging/single-pixel-buffer/single-pixel-buffer-v1.xml
        ${WaylandProtocols_DATADIR}/staging/tearing-control/tearing-control-v1.xml
        ${WaylandProtocols_DATADIR}/staging/xdg-activation/xdg-activation-v1.xml
        ${WaylandProtocols_DATADIR}/staging/xdg-dialog/xdg-dialog-v1.xml
        ${WaylandProtocols_DATADIR}/staging/xdg-system-bell/xdg-system-bell-v1.xml
        ${WaylandProtocols_DATADIR}/staging/xdg-toplevel-drag/xdg-toplevel-drag-v1.xml
        ${WaylandProtocols_DATADIR}/staging/xdg-toplevel-icon/xdg-toplevel-icon-v1.xml
        ${WaylandProtocols_DATADIR}/staging/xdg-toplevel-tag/xdg-toplevel-tag-v1.xml
        ${WaylandProtocols_DATADIR}/staging/xwayland-shell/xwayland-shell-v1.xml
        ${WaylandProtocols_DATADIR}/unstable/idle-inhibit/idle-inhibit-unstable-v1.xml
        ${WaylandProtocols_DATADIR}/unstable/input-method/input-method-unstable-v1.xml
        ${WaylandProtocols_DATADIR}/unstable/keyboard-shortcuts-inhibit/keyboard-shortcuts-inhibit-unstable-v1.xml
        ${WaylandProtocols_DATADIR}/unstable/linux-dmabuf/linux-dmabuf-unstable-v1.xml
        ${WaylandProtocols_DATADIR}/unstable/pointer-constraints/pointer-constraints-unstable-v1.xml
        ${WaylandProtocols_DATADIR}/unstable/pointer-gestures/pointer-gestures-unstable-v1.xml
        ${WaylandProtocols_DATADIR}/unstable/primary-selection/primary-selection-unstable-v1.xml
        ${WaylandProtocols_DATADIR}/unstable/relative-pointer/relative-pointer-unstable-v1.xml
        ${WaylandProtocols_DATADIR}/unstable/text-input/text-input-unstable-v1.xml
        ${WaylandProtocols_DATADIR}/unstable/text-input/text-input-unstable-v3.xml
        ${WaylandProtocols_DATADIR}/unstable/xdg-decoration/xdg-decoration-unstable-v1.xml
        ${WaylandProtocols_DATADIR}/unstable/xdg-foreign/xdg-foreign-unstable-v2.xml
        ${WaylandProtocols_DATADIR}/unstable/xdg-output/xdg-output-unstable-v1.xml
        ${WaylandProtocols_DATADIR}/unstable/xwayland-keyboard-grab/xwayland-keyboard-grab-unstable-v1.xml
)

target_sources(kwin PRIVATE
    abstract_data_source.cpp
    abstract_drop_handler.cpp
    alphamodifier_v1.cpp
    appmenu.cpp
    blur.cpp
    clientconnection.cpp
    colormanagement_v1.cpp
    colorrepresentation_v1.cpp
    compositor.cpp
    contenttype_v1.cpp
    contrast.cpp
    cursorshape_v1.cpp
    datacontroldevice_v1.cpp
    datacontroldevicemanager_v1.cpp
    datacontroloffer_v1.cpp
    datacontrolsource_v1.cpp
    datadevice.cpp
    datadevicemanager.cpp
    dataoffer.cpp
    datasource.cpp
    display.cpp
    dpms.cpp
    drmclientbuffer.cpp
    drmlease_v1.cpp
    externalbrightness_v1.cpp
    fifo_v1.cpp
    filtered_display.cpp
    fixes.cpp
    fractionalscale_v1.cpp
    frog_colormanagement_v1.cpp
    idle.cpp
    idleinhibit_v1.cpp
    idlenotify_v1.cpp
    inputmethod_v1.cpp
    keyboard.cpp
    keyboard_shortcuts_inhibit_v1.cpp
    keystate.cpp
    layershell_v1.cpp
    linux_drm_syncobj_v1.cpp
    linuxdmabufv1clientbuffer.cpp
    lockscreen_overlay_v1.cpp
    output.cpp
    output_order_v1.cpp
    outputdevice_v2.cpp
    outputmanagement_v2.cpp
    plasmashell.cpp
    plasmavirtualdesktop.cpp
    plasmawindowmanagement.cpp
    pointer.cpp
    pointerconstraints_v1.cpp
    pointergestures_v1.cpp
    presentationtime.cpp
    primaryselectiondevice_v1.cpp
    primaryselectiondevicemanager_v1.cpp
    primaryselectionoffer_v1.cpp
    primaryselectionsource_v1.cpp
    region.cpp
    relativepointer_v1.cpp
    screencast_v1.cpp
    screenedge_v1.cpp
    seat.cpp
    securitycontext_v1.cpp
    server_decoration.cpp
    server_decoration_palette.cpp
    shadow.cpp
    shmclientbuffer.cpp
    singlepixelbuffer.cpp
    slide.cpp
    subcompositor.cpp
    surface.cpp
    tablet_v2.cpp
    tearingcontrol_v1.cpp
    textinput.cpp
    textinput_v1.cpp
    textinput_v2.cpp
    textinput_v3.cpp
    touch.cpp
    transaction.cpp
    viewporter.cpp
    xdgactivation_v1.cpp
    xdgdecoration_v1.cpp
    xdgdialog_v1.cpp
    xdgforeign_v2.cpp
    xdgoutput_v1.cpp
    xdgsession_v1.cpp
    xdgshell.cpp
    xdgsystembell_v1.cpp
    xdgtopleveldrag_v1.cpp
    xdgtoplevelicon_v1.cpp
    xdgtopleveltag_v1.cpp
    xwaylandkeyboardgrab_v1.cpp
    xwaylandshell_v1.cpp
)

install(FILES
    alphamodifier_v1.h
    appmenu.h
    blur.h
    clientconnection.h
    colormanagement_v1.h
    colorrepresentation_v1.h
    compositor.h
    contenttype_v1.h
    contrast.h
    cursorshape_v1.h
    datacontroldevice_v1.h
    datacontroldevicemanager_v1.h
    datacontroloffer_v1.h
    datacontrolsource_v1.h
    datadevice.h
    datadevicemanager.h
    dataoffer.h
    datasource.h
    display.h
    dpms.h
    drmlease_v1.h
    externalbrightness_v1.h
    fifo_v1.h
    fractionalscale_v1.h
    frog_colormanagement_v1.h
    idle.h
    idleinhibit_v1.h
    idlenotify_v1.h
    inputmethod_v1.h
    keyboard.h
    keyboard_shortcuts_inhibit_v1.h
    keystate.h
    layershell_v1.h
    linux_drm_syncobj_v1.h
    lockscreen_overlay_v1.h
    output.h
    output_order_v1.h
    outputdevice_v2.h
    outputmanagement_v2.h
    plasmashell.h
    plasmavirtualdesktop.h
    plasmawindowmanagement.h
    pointer.h
    pointerconstraints_v1.h
    pointergestures_v1.h
    presentationtime.h
    primaryselectiondevice_v1.h
    primaryselectiondevicemanager_v1.h
    primaryselectionoffer_v1.h
    primaryselectionsource_v1.h
    quirks.h
    relativepointer_v1.h
    screencast_v1.h
    screenedge_v1.h
    seat.h
    securitycontext_v1.h
    server_decoration.h
    server_decoration_palette.h
    shadow.h
    singlepixelbuffer.h
    slide.h
    subcompositor.h
    surface.h
    tablet_v2.h
    tearingcontrol_v1.h
    textinput.h
    textinput_v1.h
    textinput_v2.h
    textinput_v3.h
    touch.h
    viewporter.h
    xdgactivation_v1.h
    xdgdecoration_v1.h
    xdgdialog_v1.h
    xdgforeign_v2.h
    xdgoutput_v1.h
    xdgsession_v1.h
    xdgshell.h
    xdgsystembell_v1.h
    xdgtoplevelicon_v1.h
    xdgtopleveltag_v1.h
    xwaylandkeyboardgrab_v1.h
    xwaylandshell_v1.h

    ${CMAKE_CURRENT_BINARY_DIR}/qwayland-server-alpha-modifier-v1.h
    ${CMAKE_CURRENT_BINARY_DIR}/qwayland-server-color-management-v1.h
    ${CMAKE_CURRENT_BINARY_DIR}/qwayland-server-color-representation-v1.h
    ${CMAKE_CURRENT_BINARY_DIR}/qwayland-server-content-type-v1.h
    ${CMAKE_CURRENT_BINARY_DIR}/qwayland-server-fifo-v1.h
    ${CMAKE_CURRENT_BINARY_DIR}/qwayland-server-frog-color-management-v1.h
    ${CMAKE_CURRENT_BINARY_DIR}/qwayland-server-kde-external-brightness-v1.h
    ${CMAKE_CURRENT_BINARY_DIR}/qwayland-server-linux-drm-syncobj-v1.h
    ${CMAKE_CURRENT_BINARY_DIR}/qwayland-server-presentation-time.h
    ${CMAKE_CURRENT_BINARY_DIR}/qwayland-server-single-pixel-buffer-v1.h
    ${CMAKE_CURRENT_BINARY_DIR}/qwayland-server-xdg-toplevel-tag-v1.h
    ${CMAKE_CURRENT_BINARY_DIR}/wayland-alpha-modifier-v1-server-protocol.h
    ${CMAKE_CURRENT_BINARY_DIR}/wayland-color-management-v1-server-protocol.h
    ${CMAKE_CURRENT_BINARY_DIR}/wayland-color-representation-v1-server-protocol.h
    ${CMAKE_CURRENT_BINARY_DIR}/wayland-content-type-v1-server-protocol.h
    ${CMAKE_CURRENT_BINARY_DIR}/wayland-fifo-v1-server-protocol.h
    ${CMAKE_CURRENT_BINARY_DIR}/wayland-frog-color-management-v1-server-protocol.h
    ${CMAKE_CURRENT_BINARY_DIR}/wayland-kde-external-brightness-v1-server-protocol.h
    ${CMAKE_CURRENT_BINARY_DIR}/wayland-linux-drm-syncobj-v1-server-protocol.h
    ${CMAKE_CURRENT_BINARY_DIR}/wayland-presentation-time-server-protocol.h
    ${CMAKE_CURRENT_BINARY_DIR}/wayland-single-pixel-buffer-v1-server-protocol.h
    ${CMAKE_CURRENT_BINARY_DIR}/wayland-xdg-toplevel-tag-v1-server-protocol.h

    DESTINATION ${KDE_INSTALL_INCLUDEDIR}/kwin/wayland COMPONENT Devel)

=== autotests/integration/effects/CMakeLists.txt ===
integrationTest(NAME testTranslucency SRCS translucency_test.cpp LIBS XCB::ICCCM BUILTIN_EFFECTS)
integrationTest(NAME testSlidingPopups SRCS slidingpopups_test.cpp BUILTIN_EFFECTS)
integrationTest(NAME testShadeWobblyWindows SRCS wobbly_shade_test.cpp LIBS XCB::ICCCM BUILTIN_EFFECTS)
integrationTest(NAME testScriptedEffects SRCS scripted_effects_test.cpp LIBS KF6::GlobalAccel BUILTIN_EFFECTS)
integrationTest(NAME testToplevelOpenCloseAnimation SRCS toplevel_open_close_animation_test.cpp BUILTIN_EFFECTS)
integrationTest(NAME testPopupOpenCloseAnimation SRCS popup_open_close_animation_test.cpp LIBS KF6::I18n KDecoration3::KDecoration3Private BUILTIN_EFFECTS)
integrationTest(NAME testDesktopSwitchingAnimation SRCS desktop_switching_animation_test.cpp BUILTIN_EFFECTS)
integrationTest(NAME testMinimizeAnimation SRCS minimize_animation_test.cpp BUILTIN_EFFECTS)
integrationTest(NAME testMaximizeAnimation SRCS maximize_animation_test.cpp BUILTIN_EFFECTS)

=== src/backends/wayland/CMakeLists.txt ===
target_sources(kwin PRIVATE
    color_manager.cpp
    wayland_backend.cpp
    wayland_display.cpp
    wayland_egl_backend.cpp
    wayland_logging.cpp
    wayland_output.cpp
    wayland_qpainter_backend.cpp
)

target_link_libraries(kwin PRIVATE Plasma::KWaylandClient Wayland::Client gbm::gbm)

=== src/kcms/virtualkeyboard/CMakeLists.txt ===
#SPDX-FileCopyrightText: 2020 Aleix Pol Gonzalzez <aleixpol@kde.org>
#SPDX-License-Identifier: BSD-3-Clause

add_definitions(-DTRANSLATION_DOMAIN=\"kcm_virtualkeyboard\")

kcmutils_generate_module_data(
    kcm_virtualkeyboard_PART_SRCS
    MODULE_DATA_HEADER virtualkeyboarddata.h
    MODULE_DATA_CLASS_NAME VirtualKeyboardData
    SETTINGS_HEADERS virtualkeyboardsettings.h
    SETTINGS_CLASSES VirtualKeyboardSettings
)

kconfig_add_kcfg_files(kcm_virtualkeyboard_PART_SRCS virtualkeyboardsettings.kcfgc GENERATE_MOC)
kcmutils_add_qml_kcm(kcm_virtualkeyboard SOURCES kcmvirtualkeyboard.cpp ${kcm_virtualkeyboard_PART_SRCS})

target_link_libraries(kcm_virtualkeyboard PRIVATE
    KF6::I18n
    KF6::KCMUtils
    KF6::Service
    KF6::KCMUtilsQuick
)

=== src/plugins/desktopchangeosd/CMakeLists.txt ===
kwin_add_script(desktopchangeosd package)

=== debian/changelog ===
kwin (4:6.4.5-0ubuntu3) questing; urgency=medium

  * No-change rebuild for Qt 6.9.2 private ABI.

 -- Rik Mills <rikmills@kde.org>  Thu, 18 Sep 2025 00:14:18 +0100

kwin (4:6.4.5-0ubuntu2) questing; urgency=medium

  * Drop transitional kwin-x11 package.
  * Recommend kwin-style-aurorae.

 -- Rik Mills <rikmills@kde.org>  Sun, 14 Sep 2025 21:55:35 +0100

kwin (4:6.4.5-0ubuntu1) questing; urgency=medium

  * New upstream release (6.4.5)
  * Drop included upstream patch.

 -- Rik Mills <rikmills@kde.org>  Tue, 09 Sep 2025 17:02:07 +0100

=== debian/control ===
Source: kwin
Section: kde
Priority: optional
Maintainer: Kubuntu Developers <kubuntu-devel@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Aurélien COUDERC <coucouf@debian.org>,
           Patrick Franz <deltaone@debian.org>,
Build-Depends: breeze-dev (>= 4:6.4.5~),
               cmake (>= 3.16~),
               debhelper-compat (= 13),
               dh-sequence-kf6,
               dh-sequence-python3,
               extra-cmake-modules (>= 6.14.0~),
               gettext,
               hwdata,
               kscreenlocker-dev (>= 6.4.5~),
               kwayland-dev (>= 4:6.4.5~),
               libcanberra-dev,
               libcap-dev [linux-any],
               libcap2-bin [linux-any],
               libdisplay-info-dev,
               libdrm-dev (>= 2.4.116~),
               libegl-dev (>= 1.2~),
               libeis-dev,
               libepoxy-dev (>= 1.3),
               libfontconfig-dev,
               libfreetype-dev,
               libgbm-dev,
               libice-dev,
               libinput-dev (>= 1.26~),
               libkdecorations3-dev (>= 4:6.4.5~),
               libkf6auth-dev (>= 6.14.0~),
               libkf6colorscheme-dev (>= 6.14.0~),
               libkf6config-dev (>= 6.14.0~),
               libkf6configwidgets-dev (>= 6.14.0~),
               libkf6coreaddons-dev (>= 6.14.0~),
               libkf6crash-dev (>= 6.14.0~),
               libkf6dbusaddons-dev (>= 6.14.0~),
               libkf6declarative-dev (>= 6.14.0~),
               libkf6doctools-dev (>= 6.14.0~),
               libkf6globalaccel-dev (>= 6.14.0~),
               libkf6guiaddons-dev (>= 6.14.0~),
               libkf6i18n-dev (>= 6.14.0~),
               libkf6idletime-dev (>= 6.14.0~),
               libkf6itemviews-dev (>= 6.14.0~),
               libkf6kcmutils-dev (>= 6.14.0~),
               libkf6newstuff-dev (>= 6.14.0~),
               libkf6notifications-dev (>= 6.14.0~),
               libkf6package-dev (>= 6.14.0~),
               libkf6runner-dev (>= 6.14.0~),
               libkf6service-dev (>= 6.14.0~),
               libkf6svg-dev (>= 6.14.0~),
               libkf6widgetsaddons-dev (>= 6.14.0~),
               libkf6windowsystem-dev (>= 6.14.0~),
               libkf6xmlgui-dev (>= 6.14.0~),
               libkglobalacceld-dev (>= 6.4.5~),
               libkirigami-dev (>= 6.14.0~),
               liblcms2-dev,
               libpipewire-0.3-dev (>= 0.3.29),
               libplasma-dev (>= 6.4.5~),
               libplasmaactivities-dev (>= 6.4.5~),
               libqaccessibilityclient-qt6-dev,
               libsm-dev,
               libsystemd-dev,
               libudev-dev [linux-any],
               libwayland-dev (>= 1.22~),
               libx11-xcb-dev,
               libxcb-composite0-dev (>= 1.10~),
               libxcb-cursor-dev,
               libxcb-damage0-dev (>= 1.10~),
               libxcb-dri3-dev (>= 1.10~),
               libxcb-glx0-dev (>= 1.10~),
               libxcb-icccm4-dev,
               libxcb-image0-dev,
               libxcb-keysyms1-dev,
               libxcb-present-dev (>= 1.10~),
               libxcb-randr0-dev (>= 1.10~),
               libxcb-render0-dev (>= 1.10~),
               libxcb-res0-dev,
               libxcb-shape0-dev (>= 1.10~),
               libxcb-shm0-dev (>= 1.10~),
               libxcb-sync-dev (>= 1.10~),
               libxcb-util-dev,
               libxcb-xfixes0-dev (>= 1.10~),
               libxcb-xinerama0-dev (>= 1.10~),
               libxcb-xinput-dev (>= 1.10~),
               libxcb-xkb-dev (>= 1.10~),
               libxcb-xtest0-dev,
               libxcb1-dev (>= 1.10~),
               libxcursor-dev,
               libxcvt-dev (>= 0.1.1~),
               libxkbcommon-dev (>= 0.7.0~),
               libxkbcommon-x11-dev,
               pkgconf,
               plasma-wayland-protocols (>= 1.18.0~),
               python3:any,
               qt6-5compat-dev (>= 6.8.0~),
               qt6-base-dev (>= 6.8.0~),
               qt6-base-private-dev (>= 6.8.0+dfsg~),
               qt6-declarative-dev (>= 6.8.0~),
               qt6-declarative-private-dev (>= 6.8.0~),
               qt6-sensors-dev (>= 6.8.0~),
               qt6-svg-dev (>= 6.8.0~),
               qt6-tools-dev (>= 6.8.0~),
               qt6-wayland-dev (>= 6.8.0~),
               qt6-wayland-dev-tools (>= 6.8.0~),
               wayland-protocols (>= 1.44~),
               xwayland (>= 2:22.1.7-1~),
Standards-Version: 4.7.0
Homepage: https://projects.kde.org/projects/kde/workspace/kwin
Vcs-Browser: https://code.launchpad.net/~kubuntu-packagers/kubuntu-packaging/+git/kwin
Vcs-Git: https://git.launchpad.net/~kubuntu-packagers/kubuntu-packaging/+git/kwin
Rules-Requires-Root: no

Package: kwin-common
Architecture: any
Depends: hwdata,
         kglobalacceld,
         kwin-data (= ${source:Version}),
         plasma-desktoptheme,
         qml6-module-org-kde-kirigami,
         qml6-module-org-kde-ksvg,
         qml6-module-qt5compat-graphicaleffects,
         qml6-module-qtquick,
         qml6-module-qtquick-window,
         ${misc:Depends},
         ${shlibs:Depends},
Recommends: plasma-desktop (>= 4:6.2.90~),
Suggests: kwin-addons (>= 4:6.2.90~),
Description: KDE window manager, common files
 KWin (pronounced as one syllable "kwin") is the window
 manager for the KDE Plasma Desktop. It gives you complete
 control over your windows, making sure they're not in the way
 but aid you in your task. It paints the window decoration,
 the bar on top of every window with (configurable) buttons
 like close, maximize and minimize. It also handles placing
 of windows and switching between them.
 .
 This package is part of the KDE base workspace module.

Package: kwin-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}, ${python3:Depends},
Recommends: plasma-desktoptheme,
            qml6-module-org-kde-kirigami,
            qml6-module-org-kde-kitemmodels,
            qml6-module-org-kde-kquickcontrolsaddons,
            qml6-module-org-kde-ksvg,
            qml6-module-org-kde-quickcharts,
            qml6-module-qt5compat-graphicaleffects,
            qml6-module-qtqml-workerscript,
            qml6-module-qtmultimedia,
            qml6-module-qtquick,
            qml6-module-qtquick-controls,
            qml6-module-qtquick-layouts,
            qml6-module-qtquick-window,
            systemsettings,
Breaks: kwin-addons (<< 4:6.1.4~),
Replaces: kwin-addons (<< 4:6.1.4~),
Description: KDE window manager data files
 KWin (pronounced as one syllable "kwin") is the window
 manager for the KDE Plasma Desktop. It gives you complete
 control over your windows, making sure they're not in the way
 but aid you in your task. It paints the window decoration,
 the bar on top of every window with (configurable) buttons
 like close, maximize and minimize. It also handles placing
 of windows and switching between them.
 .
 This package contains the data files

Package: kwin-dev
Section: libdevel
Architecture: any
Depends: kwin-common (= ${binary:Version}),
         libepoxy-dev (>= 1.3),
         libkf6config-dev (>= 6.14.0~),
         libkf6coreaddons-dev (>= 6.14.0~),
         libkf6windowsystem-dev (>= 6.14.0~),
         libkwin6 (= ${binary:Version}),
         qt6-base-dev (>= 6.8.0~),
         qt6-declarative-dev (>= 6.8.0~),
         ${misc:Depends},
Description: KDE window manager - devel files
 KWin (pronounced as one syllable "kwin") is the window
 manager for the KDE Plasma Desktop. It gives you complete
 control over your windows, making sure they're not in the way
 but aid you in your task. It paints the window decoration,
 the bar on top of every window with (configurable) buttons
 like close, maximize and minimize. It also handles placing
 of windows and switching between them.
 .
 This package is part of the KDE base workspace module.

Package: kwin-wayland
Architecture: any
Depends: libcap2-bin [linux-any], xwayland, ${misc:Depends}, ${shlibs:Depends},
Recommends: kwin-style-aurorae, xwaylandvideobridge,
Provides: kwin,
Description: KDE window manager, Wayland version
 KWin (pronounced as one syllable "kwin") is the window
 manager for the KDE Plasma Desktop. It gives you complete
 control over your windows, making sure they're not in the way
 but aid you in your task. It paints the window decoration,
 the bar on top of every window with (configurable) buttons
 like close, maximize and minimize. It also handles placing
 of windows and switching between them.
 .
 This package provides the wayland version, which is still a work in progress
 project, and is available as a PREVIEW release. Don't expect the same
 stability as with the x11 version.

Package: libkwin6
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends},
Description: KDE window manager library
 KWin (pronounced as one syllable "kwin") is the window
 manager for the KDE Plasma Desktop. It gives you complete
 control over your windows, making sure they're not in the way
 but aid you in your task. It paints the window decoration,
 the bar on top of every window with (configurable) buttons
 like close, maximize and minimize. It also handles placing
 of windows and switching between them.
 .
 This package is part of the KDE base workspace module.
